// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "asset/AssetLoader.hpp"
#include "asset/AssetDataLoader.hpp"

namespace Dawn {
  enum class StringLoaderState {
    INITIAL,
    LOADING_STRING,
    DONE
  };

  class StringLoader : public AssetLoader {
    protected:
      AssetDataLoader loader;
      enum StringLoaderState state;

    public:
      const static std::string ASSET_TYPE;

      std::string data;

      StringLoader(
        const std::shared_ptr<AssetManager> assetManager,
        const std::string name
      );
      void updateSync() override;
      void updateAsync() override;
      std::string getAssetType() const override;
      ~StringLoader();
  };
}