// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "asset/loader/JSONLoader.hpp"
#include "SceneLoadContext.hpp"

namespace Dawn {
  class LoaderForSceneitems;

  class LoaderForSceneItems :
    public AssetLoader,
    public std::enable_shared_from_this<LoaderForSceneItems>
  {
    protected:
      std::shared_ptr<JSONLoader> jsonLoader;

      /**
       * Loads the dependencies into the context for the data available in
       * the jsonLoader.
       */
      void setupDependencies();

    public:
      const std::shared_ptr<SceneLoadContext> ctx;

      LoaderForSceneItems(
        const std::shared_ptr<AssetManager> assetManager,
        const std::string name
      );

      ~LoaderForSceneItems();

      friend class SceneLoader;
      friend class PrefabLoader;
  };
}