// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneComponent.hpp"
#include "component/display/IRenderableComponent.hpp"

namespace Dawn {
  class Material :
    public SceneComponent,
    public IRenderableComponent
  {
    protected:
      /**
       * Load the shaders for this material.
       */
      virtual void initShaderPrograms(
        
      ) = 0;

    public:
      void onInit() override;
      void onDispose() override;
  };
}