// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "MeshComponent.hpp"

namespace Dawn {
  class PlaneMeshComponent final : public MeshComponent {
    protected:
      int32_t columns;
      int32_t rows;
      glm::vec2 planeSize;
      glm::vec4 uv;

      void meshLoad(std::shared_ptr<SceneLoadContext> ctx) override;
      void meshBuffer(std::shared_ptr<Mesh> mesh) override;

    public:
      void setColumns(const int32_t columns);
      void setRows(const int32_t rows);
      void setPlaneSize(const glm::vec2 &planeSize);
      void setUV(const glm::vec4 &uv);
  };
}