// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "RenderPass.hpp"
#include "component/display/MeshRenderer.hpp"

using namespace Dawn;

RenderPass::RenderPass(
  SceneComponent &self,
  const std::shared_ptr<Mesh> mesh,
  const enum MeshDrawMode drawMode,
  const int32_t indiceStart,
  const int32_t indiceCount,
  const std::shared_ptr<ShaderProgram> shaderProgram
) :
  mesh(mesh),
  drawMode(drawMode),
  indiceStart(indiceStart),
  indiceCount(indiceCount),
  shaderProgram(shaderProgram)
{
  // Need mesh?
  if(!this->mesh) {
    auto meshRenderer = self.getItem()->getComponent<MeshRenderer>();
    if(meshRenderer) this->mesh = meshRenderer->mesh;
  }
}

void RenderPass::draw() {
  // mesh->draw(drawMode, indiceStart, indiceCount);
}

RenderPass::~RenderPass() {
  
}