// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "dawn.hpp"
#include "slang.h"

using namespace slang;

namespace Dawn {
  class IShaderStage {
    public:
      /**
       * Initialize the IShaderEntry object
       * 
       * @param stage The stage of the shader entry.
       * @param code The code of the shader entry.
       */
      virtual void init(
        const SlangStage &stage,
        const std::string &code
      ) = 0;

      /**
       * Destroy the IShaderEntry object
       */
      virtual ~IShaderStage();
  };
}