// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/shader/IShaderStage.hpp"
#include "dawnopengl.hpp"

namespace Dawn {
  class ShaderProgram;

  class ShaderStage : public IShaderStage {
    protected:
      GLenum shaderType;
      GLuint id = -1;

    public:
      void init(
        const SlangStage &stage,
        const std::string &code
      ) override;
      
      ~ShaderStage();
      
      friend class ShaderProgram;
  };
}