// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "CubeCollider.hpp"

using namespace Dawn;

std::shared_ptr<JPH::ShapeSettings> CubeCollider::getShapeSettings() {
  return std::make_shared<JPH::BoxShapeSettings>(
    JPH::Vec3(shape.x, shape.y, shape.z)
  );
}

glm::vec3 CubeCollider::getShape() {
  return shape;
}

void CubeCollider::setShape(const glm::vec3 &shape) {
  this->shape = shape;
  this->notifyShapeChanged();
}