// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "Collider.hpp"

namespace Dawn {
  class CubeCollider : public Collider {
    private:
      glm::vec3 shape = glm::vec3(1, 1, 1);

    protected:
      std::shared_ptr<JPH::ShapeSettings> getShapeSettings() override;

    public:
      /**
       * Returns the shape of the cube collider.
       * 
       * @return The shape of the cube collider.
       */
      glm::vec3 getShape();

      /**
       * Sets the shape of the cube collider.
       * 
       * @param shape The shape of the cube collider.
       */
      void setShape(const glm::vec3 &shape);
  };
}