// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "game/IGame.hpp"
#include "rpg/RPGManager.hpp"

namespace Dawn {
  class Game :
    public IGame
  {
    protected:
      std::string getInitialScene() override;
      void initManagers() override;

    public:
      std::shared_ptr<RPGManager> rpgManager;

      Game();
      ~Game();
  };
}