// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "RPGManager.hpp"
#include "assert/assert.hpp"

using namespace Dawn;

void RPGManager::init(const std::shared_ptr<Game> &game) {
  this->game = game; 
}

std::shared_ptr<Game> RPGManager::getGame() {
  auto l = this->game.lock();
  assertNotNull(l, "Game is null?");
  return l;
}